# Create

Launch stage: GA

`POST /api/2.1/clusters/create`

Creates a new Spark cluster. This method will acquire new instances from the cloud provider
 if necessary. This method is asynchronous; the returned ``cluster_id`` can be used to poll the
 cluster status. When this method returns, the cluster will be in
 a ``PENDING`` state. The cluster will be usable once it enters a ``RUNNING`` state.
 Note: <Databricks> may not be able to acquire some of the requested nodes, due to cloud provider
 limitations (account limits, spot price, etc.) or transient network issues.

 If <Databricks> acquires at least 85% of the requested on-demand nodes, cluster creation will succeed.
 Otherwise the cluster will terminate with an informative error message.

 Rather than authoring the cluster's JSON definition from scratch, Databricks recommends filling out the
 [create compute UI](https://docs.databricks.com/compute/configure.html) and then copying the generated JSON definition from the UI.

API scopes: clusters

## Request body

- `apply_policy_default_values` (boolean, optional)
  When set to true, fixed and default values from the policy will be used for fields that are omitted.
   When set to false, only fixed values from the policy will be applied.
  Default: `false`
- `clone_from` (object, optional)
  When specified, this clones libraries from a source cluster during the creation of a new cluster.
  - `source_cluster_id` (string, optional)
    The cluster that is being cloned.
- `num_workers` (int32, required)
  Number of worker nodes that this cluster should have. A cluster has one Spark Driver
   and `num_workers` Executors for a total of `num_workers` + 1 Spark nodes.
  
   Note: When reading the properties of a cluster, this field reflects the desired number
   of workers rather than the actual current number of workers. For instance, if a cluster
   is resized from 5 to 10 workers, this field will immediately be updated to reflect
   the target size of 10 workers, whereas the workers listed in `spark_info` will gradually
   increase from 5 to 10 as the new nodes are provisioned.
- `autoscale` (object, required)
  Parameters needed in order to automatically scale clusters up and down based on load.
   Note: autoscaling works best with DB runtime versions 3.0 or later.
  - `min_workers` (int32, optional)
    The minimum number of workers to which the cluster can scale down when underutilized.
     It is also the initial number of workers the cluster will have after creation.
  - `max_workers` (int32, optional)
    The maximum number of workers to which the cluster can scale up when overloaded.
     Note that `max_workers` must be strictly greater than `min_workers`.
- `cluster_name` (string, optional)
  Cluster name requested by the user. This doesn't have to be unique.
   If not specified at creation, the cluster name will be an empty string.
   For job clusters, the cluster name is automatically set based on the job and job run IDs.
- `spark_version` (string, optional)
  The Spark version of the cluster, e.g. `3.3.x-scala2.11`.
   A list of available Spark versions can be retrieved by using
   the [clusters/sparkVersions](https://docs.databricks.com/api/workspace/clusters/sparkversions) API call.
- `spark_conf` (object, optional)
  An object containing a set of optional, user-specified Spark configuration key-value pairs.
   Users can also pass in a string of extra JVM options to the driver and the executors via
   `spark.driver.extraJavaOptions` and `spark.executor.extraJavaOptions` respectively.
- `aws_attributes` (object, optional)
  Attributes related to clusters running on Amazon Web Services.
   If not specified at cluster creation, a set of default values will be used.
  - `first_on_demand` (int32, optional)
    The first `first_on_demand` nodes of the cluster will be placed on on-demand instances.
     If this value is greater than 0, the cluster driver node in particular will be placed on an
     on-demand instance. If this value is greater than or equal to the current cluster size, all
     nodes will be placed on on-demand instances. If this value is less than the current cluster
     size, `first_on_demand` nodes will be placed on on-demand instances and the remainder will
     be placed on `availability` instances. Note that this value does not affect
     cluster size and cannot currently be mutated over the lifetime of a cluster.
    Default: `0`
  - `availability` (string, optional)
    Possible values: `SPOT`, `ON_DEMAND`, `SPOT_WITH_FALLBACK`
    Default: `SPOT_WITH_FALLBACK`
  - `zone_id` (string, optional)
    Identifier for the availability zone/datacenter in which the cluster resides.
     This string will be of a form like "us-west-2a". The provided availability
     zone must be in the same region as the <Databricks> deployment. For example, "us-west-2a"
     is not a valid zone id if the <Databricks> deployment resides in the "us-east-1" region.
     This is an optional field at cluster creation, and if not specified, the zone "auto" will be used.
     If the zone specified is "auto", will try to place cluster in a zone with high availability,
     and will retry placement in a different AZ if there is not enough capacity.
     
     The list of available zones as well as the default value can be found by using the
     `List Zones` method.
  - `instance_profile_arn` (string, optional)
    Nodes for this cluster will only be placed on AWS instances with this instance profile. If
     ommitted, nodes will be placed on instances without an IAM instance profile. The instance
     profile must have previously been added to the <Databricks> environment by an account
     administrator.
    
     This feature may only be available to certain customer plans.
  - `spot_bid_price_percent` (int32, optional)
    The bid price for AWS spot instances, as a percentage of the corresponding instance type's
     on-demand price.
     For example, if this field is set to 50, and the cluster needs a new `r3.xlarge` spot
     instance, then the bid price is half of the price of
     on-demand `r3.xlarge` instances. Similarly, if this field is set to 200, the bid price is twice
     the price of on-demand `r3.xlarge` instances. If not specified, the default value is 100.
     When spot instances are requested for this cluster, only spot instances whose bid price
     percentage matches this field will be considered.
     Note that, for safety, we enforce this field to be no more than 10000.
    Default: `100`
  - `ebs_volume_type` (string, optional)
    The type of EBS volumes that will be launched with this cluster.
    Possible values: `GENERAL_PURPOSE_SSD`, `THROUGHPUT_OPTIMIZED_HDD`
  - `ebs_volume_count` (int32, optional)
    The number of volumes launched for each instance. Users can choose up to 10 volumes.
     This feature is only enabled for supported node types. Legacy node types cannot specify
     custom EBS volumes.
     For node types with no instance store, at least one EBS volume needs to be specified;
     otherwise, cluster creation will fail.
    
     These EBS volumes will be mounted at `/ebs0`, `/ebs1`, and etc.
     Instance store volumes will be mounted at `/local_disk0`, `/local_disk1`, and etc.
    
     If EBS volumes are attached, <Databricks> will configure Spark to use only the EBS volumes for
     scratch storage because heterogenously sized scratch devices can lead to inefficient disk
     utilization. If no EBS volumes are attached, <Databricks> will configure Spark to use instance
     store volumes.
    
     Please note that if EBS volumes are specified, then the Spark configuration `spark.local.dir`
     will be overridden.
    Default: `0`
  - `ebs_volume_size` (int32, optional)
    The size of each EBS volume (in GiB) launched for each instance. For general purpose
     SSD, this value must be within the range 100 - 4096. For throughput optimized HDD,
     this value must be within the range 500 - 4096.
  - `ebs_volume_iops` (int32, optional)
    If using gp3 volumes, what IOPS to use for the disk. If this is not set, the maximum performance of a gp2 volume with the same volume size will be used.
  - `ebs_volume_throughput` (int32, optional)
    If using gp3 volumes, what throughput to use for the disk. If this is not set, the maximum performance of a gp2 volume with the same volume size will be used.
- `azure_attributes` (object, optional)
  Attributes related to clusters running on Microsoft Azure.
   If not specified at cluster creation, a set of default values will be used.
  - `log_analytics_info` (object, optional)
    Defines values necessary to configure and run Azure Log Analytics agent
    - `log_analytics_workspace_id` (string, optional)
    - `log_analytics_primary_key` (string, optional)
  - `first_on_demand` (int32, optional)
    The first `first_on_demand` nodes of the cluster will be placed on on-demand instances.
     This value should be greater than 0, to make sure the cluster driver node is placed on an
     on-demand instance. If this value is greater than or equal to the current cluster size, all
     nodes will be placed on on-demand instances. If this value is less than the current cluster
     size, `first_on_demand` nodes will be placed on on-demand instances and the remainder will
     be placed on `availability` instances. Note that this value does not affect
     cluster size and cannot currently be mutated over the lifetime of a cluster.
    Default: `1`
  - `availability` (string, optional)
    Availability type used for all subsequent nodes past the `first_on_demand` ones.
     Note: If `first_on_demand` is zero, this availability
     type will be used for the entire cluster.
    Possible values: `SPOT_AZURE`, `ON_DEMAND_AZURE`, `SPOT_WITH_FALLBACK_AZURE`
    Default: `ON_DEMAND_AZURE`
  - `spot_bid_max_price` (double, optional)
    The max bid price to be used for Azure spot instances.
     The Max price for the bid cannot be higher than the on-demand price of the instance.
     If not specified, the default value is -1, which specifies that the instance cannot be evicted
     on the basis of price, and only on the basis of availability. Further, the value should > 0 or -1.
    Default: `-1`
  - `capacity_reservation_group` (string, optional)
    The Azure capacity reservation group resource ID to use for launching VMs.
     When specified, VMs will be launched using the provided capacity reservation.
    
     Capacity reservations can only be specified when the workspace uses injected vnet (i.e. customer defined vnet not
     managed by databricks). Ensure the databricks-login-prod Enterprise Application is granted the following four permissions:
     1. Microsoft.Compute/capacityReservationGroups/read
     2. Microsoft.Compute/capacityReservationGroups/deploy/action
     3. Microsoft.Compute/capacityReservationGroups/capacityReservations/read
     4. Microsoft.Compute/capacityReservationGroups/capacityReservations/deploy/action
    
     Format: `/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/capacityReservationGroups/{capacityReservationGroupName}`
- `gcp_attributes` (object, optional)
  Attributes related to clusters running on Google Cloud Platform.
   If not specified at cluster creation, a set of default values will be used.
  - `use_preemptible_executors` (boolean, optional)
    This field determines whether the spark executors will be scheduled to run on preemptible
     VMs (when set to true) versus standard compute engine VMs (when set to false; default).
     Note: Soon to be deprecated, use the 'availability' field instead.
    Default: `false`
  - `google_service_account` (string, optional)
    If provided, the cluster will impersonate the google service account when accessing
     gcloud services (like GCS). The google service account
     must have previously been added to the <Databricks> environment by an account
     administrator.
  - `boot_disk_size` (int32, optional)
    Boot disk size in GB
  - `availability` (string, optional)
    This field determines whether the spark executors will be scheduled to run on preemptible
     VMs, on-demand VMs, or preemptible VMs with a fallback to on-demand VMs if the former is unavailable.
    Possible values: `PREEMPTIBLE_GCP`, `ON_DEMAND_GCP`, `PREEMPTIBLE_WITH_FALLBACK_GCP`
    Default: `ON_DEMAND_GCP`
  - `zone_id` (string, optional)
    Identifier for the availability zone in which the cluster resides.
     This can be one of the following:
     - "HA" => High availability, spread nodes across availability zones for a
        <Databricks> deployment region [default].
     - "AUTO" => <Databricks> picks an availability zone to schedule the cluster on.
     - A GCP availability zone => Pick One of the available zones for (machine type + region) from
       https://cloud.google.com/compute/docs/regions-zones.
    Default: `HA`
  - `local_ssd_count` (int32, optional)
    If provided, each node (workers and driver) in the cluster will have this number of local SSDs attached.
     Each local SSD is 375GB in size.
     Refer to [GCP documentation](https://cloud.google.com/compute/docs/disks/local-ssd#choose_number_local_ssds)
     for the supported number of local SSDs for each instance type.
  - `first_on_demand` (int32, optional)
    The first `first_on_demand` nodes of the cluster will be placed on on-demand instances.
     This value should be greater than 0, to make sure the cluster driver node is placed on an
     on-demand instance. If this value is greater than or equal to the current cluster size, all
     nodes will be placed on on-demand instances. If this value is less than the current cluster
     size, `first_on_demand` nodes will be placed on on-demand instances and the remainder will
     be placed on `availability` instances. Note that this value does not affect
     cluster size and cannot currently be mutated over the lifetime of a cluster.
    Default: `1`
- `node_type_id` (string, optional)
  This field encodes, through a single value, the resources available to each of
   the Spark nodes in this cluster. For example, the Spark nodes can be provisioned
   and optimized for memory or compute intensive workloads. A list of available node
   types can be retrieved by using the [clusters/listNodeTypes](https://docs.databricks.com/api/workspace/clusters/listnodetypes) API call.
- `driver_node_type_id` (string, optional)
  The node type of the Spark driver.
   Note that this field is optional; if unset, the driver node type will be set as the same value
   as `node_type_id` defined above.
  
    This field, along with node_type_id, should not be set if virtual_cluster_size is set.
    If both driver_node_type_id, node_type_id, and virtual_cluster_size are specified, driver_node_type_id and node_type_id take precedence.
- `worker_node_type_flexibility` (object, optional)
  Flexible node type configuration for worker nodes.
  - `alternate_node_type_ids` (array of string, optional)
    A list of node type IDs to use as fallbacks when the primary node type is unavailable.
- `driver_node_type_flexibility` (object, optional)
  Flexible node type configuration for the driver node.
  - `alternate_node_type_ids` (array of string, optional)
    A list of node type IDs to use as fallbacks when the primary node type is unavailable.
- `ssh_public_keys` (array of string, optional)
  SSH public key contents that will be added to each Spark node in this cluster. The
   corresponding private keys can be used to login with the user name `ubuntu` on port `2200`.
   Up to 10 keys can be specified.
- `custom_tags` (object, optional)
  Additional tags for cluster resources. <Databricks> will tag all cluster resources (e.g., AWS
   instances and EBS volumes) with these tags in addition to `default_tags`. Notes:
  
   - Currently, <Databricks> allows at most 45 custom tags
  
   - Clusters can only reuse cloud resources if the resources' tags are a subset of the cluster tags
- `cluster_log_conf` (object, optional)
  The configuration for delivering spark logs to a long-term storage destination.
   Three kinds of destinations (DBFS, S3 and Unity Catalog volumes) are supported. Only one destination can be specified
   for one cluster. If the conf is given, the logs will be delivered to the destination every
   `5 mins`. The destination of driver logs is `$destination/$clusterId/driver`, while
   the destination of executor logs is `$destination/$clusterId/executor`.
  - `dbfs` (object, required)
    destination needs to be provided. e.g.
     `{ "dbfs" : { "destination" : "dbfs:/home/cluster_log" } }`
    - `destination` (string, optional)
      dbfs destination, e.g. `dbfs:/my/path`
  - `s3` (object, required)
    destination and either the region or endpoint need to be provided. e.g.
     `{ "s3": { "destination" : "s3://cluster_log_bucket/prefix", "region" : "us-west-2" } }`
     Cluster iam role is used to access s3, please make sure the cluster iam role in
     `instance_profile_arn` has permission to write data to the s3 destination.
    - `destination` (string, optional)
      S3 destination, e.g. `s3://my-bucket/some-prefix` Note that logs will be delivered using
       cluster iam role, please make sure you set cluster iam role and the role has write access to the
       destination. Please also note that you cannot use AWS keys to deliver logs.
    - `region` (string, optional)
      S3 region, e.g. `us-west-2`. Either region or endpoint needs to be set. If both are set,
       endpoint will be used.
    - `endpoint` (string, optional)
      S3 endpoint, e.g. `https://s3-us-west-2.amazonaws.com`. Either region or endpoint needs to be set.
       If both are set, endpoint will be used.
    - `enable_encryption` (boolean, optional)
      (Optional) Flag to enable server side encryption, `false` by default.
    - `encryption_type` (string, optional)
      (Optional) The encryption type, it could be `sse-s3` or `sse-kms`. It will be used only when
       encryption is enabled and the default type is `sse-s3`.
    - `kms_key` (string, optional)
      (Optional) Kms key which will be used if encryption is enabled and encryption type is set to `sse-kms`.
    - `canned_acl` (string, optional)
      (Optional) Set canned access control list for the logs, e.g. `bucket-owner-full-control`.
       If `canned_cal` is set, please make sure the cluster iam role has `s3:PutObjectAcl` permission on
       the destination bucket and prefix. The full list of possible canned acl can be found at
       http://docs.aws.amazon.com/AmazonS3/latest/dev/acl-overview.html#canned-acl.
       Please also note that by default only the object owner gets full controls. If you are using cross account
       role for writing data, you may want to set `bucket-owner-full-control` to make bucket owner able to
       read the logs.
  - `volumes` (object, required)
    destination needs to be provided, e.g.
     `{ "volumes": { "destination": "/Volumes/catalog/schema/volume/cluster_log" } }`
    - `destination` (string, optional)
      UC Volumes destination, e.g. `/Volumes/catalog/schema/vol1/init-scripts/setup-datadog.sh`
       or `dbfs:/Volumes/catalog/schema/vol1/init-scripts/setup-datadog.sh`
- `spark_env_vars` (object, optional)
  An object containing a set of optional, user-specified environment variable key-value pairs.
   Please note that key-value pair of the form (X,Y) will be exported as is (i.e.,
   `export X='Y'`) while launching the driver and workers.
  
   In order to specify an additional set of `SPARK_DAEMON_JAVA_OPTS`, we recommend appending
   them to `$SPARK_DAEMON_JAVA_OPTS` as shown in the example below. This ensures that all
   default databricks managed environmental variables are included as well.
  
   Example Spark environment variables:
   `{"SPARK_WORKER_MEMORY": "28000m", "SPARK_LOCAL_DIRS": "/local_disk0"}` or
   `{"SPARK_DAEMON_JAVA_OPTS": "$SPARK_DAEMON_JAVA_OPTS -Dspark.shuffle.service.enabled=true"}`
- `autotermination_minutes` (int32, optional)
  Automatically terminates the cluster after it is inactive for this time in minutes. If not set,
   this cluster will not be automatically terminated. If specified, the threshold must be between
   10 and 10000 minutes.
   Users can also set this value to 0 to explicitly disable automatic termination.
- `enable_elastic_disk` (boolean, optional)
  Autoscaling Local Storage: when enabled, this cluster will dynamically acquire additional disk
   space when its Spark workers are running low on disk space.
  **AWS:** Autoscaling Local Storage: when enabled, this cluster will dynamically acquire additional disk
  space when its Spark workers are running low on disk space.  This feature requires specific AWS
  permissions to function correctly - refer to the User Guide for more details.
- `init_scripts` (array of object, optional)
  The configuration for storing init scripts. Any number of destinations can be specified.
   The scripts are executed sequentially in the order provided.
   If `cluster_log_conf` is specified, init script logs are sent to `<destination>/<cluster-ID>/init_scripts`.
  - `dbfs` (object, required)
    destination needs to be provided. e.g.
     `{ "dbfs": { "destination" : "dbfs:/home/cluster_log" } }`
    - `destination` (string, optional)
      dbfs destination, e.g. `dbfs:/my/path`
  - `s3` (object, required)
    destination and either the region or endpoint need to be provided. e.g.
     `{ \"s3\": { \"destination\": \"s3://cluster_log_bucket/prefix\", \"region\": \"us-west-2\" } }`
     Cluster iam role is used to access s3, please make sure the cluster iam role in
     `instance_profile_arn` has permission to write data to the s3 destination.
    - `destination` (string, optional)
      S3 destination, e.g. `s3://my-bucket/some-prefix` Note that logs will be delivered using
       cluster iam role, please make sure you set cluster iam role and the role has write access to the
       destination. Please also note that you cannot use AWS keys to deliver logs.
    - `region` (string, optional)
      S3 region, e.g. `us-west-2`. Either region or endpoint needs to be set. If both are set,
       endpoint will be used.
    - `endpoint` (string, optional)
      S3 endpoint, e.g. `https://s3-us-west-2.amazonaws.com`. Either region or endpoint needs to be set.
       If both are set, endpoint will be used.
    - `enable_encryption` (boolean, optional)
      (Optional) Flag to enable server side encryption, `false` by default.
    - `encryption_type` (string, optional)
      (Optional) The encryption type, it could be `sse-s3` or `sse-kms`. It will be used only when
       encryption is enabled and the default type is `sse-s3`.
    - `kms_key` (string, optional)
      (Optional) Kms key which will be used if encryption is enabled and encryption type is set to `sse-kms`.
    - `canned_acl` (string, optional)
      (Optional) Set canned access control list for the logs, e.g. `bucket-owner-full-control`.
       If `canned_cal` is set, please make sure the cluster iam role has `s3:PutObjectAcl` permission on
       the destination bucket and prefix. The full list of possible canned acl can be found at
       http://docs.aws.amazon.com/AmazonS3/latest/dev/acl-overview.html#canned-acl.
       Please also note that by default only the object owner gets full controls. If you are using cross account
       role for writing data, you may want to set `bucket-owner-full-control` to make bucket owner able to
       read the logs.
  - `file` (object, required)
    destination needs to be provided, e.g.
     `{ "file": { "destination": "file:/my/local/file.sh" } }`
    - `destination` (string, optional)
      local file destination, e.g. `file:/my/local/file.sh`
  - `gcs` (object, required)
    destination needs to be provided, e.g.
     `{ "gcs": { "destination": "gs://my-bucket/file.sh" } }`
    - `destination` (string, optional)
      GCS destination/URI, e.g. `gs://my-bucket/some-prefix`
  - `abfss` (object, required)
    destination needs to be provided, e.g.
     `abfss://<container-name>@<storage-account-name>.dfs.core.windows.net/<directory-name>`
    - `destination` (string, optional)
      abfss destination, e.g. `abfss://<container-name>@<storage-account-name>.dfs.core.windows.net/<directory-name>`.
  - `workspace` (object, required)
    destination needs to be provided, e.g.
     `{ "workspace": { "destination": "/cluster-init-scripts/setup-datadog.sh" } }`
    - `destination` (string, optional)
      wsfs destination, e.g. `workspace:/cluster-init-scripts/setup-datadog.sh`
  - `volumes` (object, required)
    destination needs to be provided. e.g.
     `{ \"volumes\" : { \"destination\" : \"/Volumes/my-init.sh\" } }`
    - `destination` (string, optional)
      UC Volumes destination, e.g. `/Volumes/catalog/schema/vol1/init-scripts/setup-datadog.sh`
       or `dbfs:/Volumes/catalog/schema/vol1/init-scripts/setup-datadog.sh`
- `docker_image` (object, optional)
  Custom docker image BYOC
  - `url` (string, optional)
    URL of the docker image.
  - `basic_auth` (object, required)
    Basic auth with username and password
    - `username` (string, optional)
      Name of the user
    - `password` (string, optional)
      Password of the user
- `instance_pool_id` (string, optional)
  The optional ID of the instance pool to which the cluster belongs.
- `single_user_name` (string, optional)
  Single user name if data_security_mode is `SINGLE_USER`
- `policy_id` (string, optional)
  The ID of the cluster policy used to create the cluster if applicable.
- `enable_local_disk_encryption` (boolean, optional)
  Whether to enable LUKS on cluster VMs' local disks
- `driver_instance_pool_id` (string, optional)
  The optional ID of the instance pool for the driver of the cluster belongs.
   The pool cluster uses the instance pool with id (instance_pool_id) if the driver pool is not
   assigned.
- `workload_type` (object, optional)
  - `clients` (object, optional)
    defined what type of clients can use the cluster. E.g. Notebooks, Jobs
    - `notebooks` (boolean, optional)
      With notebooks set, this cluster can be used for notebooks
      Default: `true`
    - `jobs` (boolean, optional)
      With jobs set, the cluster can be used for jobs
      Default: `true`
- `data_security_mode` (string, optional)
  Possible values: `NONE`, `SINGLE_USER`, `USER_ISOLATION`, `LEGACY_TABLE_ACL`, `LEGACY_PASSTHROUGH`, `LEGACY_SINGLE_USER`, `LEGACY_SINGLE_USER_STANDARD`, `DATA_SECURITY_MODE_STANDARD`, `DATA_SECURITY_MODE_DEDICATED`, `DATA_SECURITY_MODE_AUTO`
- `runtime_engine` (string, optional)
  Determines the cluster's runtime engine, either standard or Photon.
  
   This field is not compatible with legacy `spark_version` values that contain `-photon-`.
   Remove `-photon-` from the `spark_version` and set `runtime_engine` to `PHOTON`.
  
   If left unspecified, the runtime engine defaults to standard unless the spark_version
   contains -photon-, in which case Photon will be used.
  Possible values: `NULL`, `STANDARD`, `PHOTON`
- `kind` (string, optional)
  Possible values: `COMPUTE_KIND_UNSPECIFIED`, `CLASSIC_PREVIEW`
- `use_ml_runtime` (boolean, optional)
  This field can only be used when `kind = CLASSIC_PREVIEW`.
  
   `effective_spark_version` is determined by `spark_version` (DBR release), this field `use_ml_runtime`, and whether `node_type_id` is gpu node or not.
- `is_single_node` (boolean, optional)
  This field can only be used when `kind = CLASSIC_PREVIEW`.
  
   When set to true, <Databricks> will automatically set single node related `custom_tags`, `spark_conf`, and `num_workers`
- `remote_disk_throughput` (int32, optional)
  If set, what the configurable throughput (in Mb/s) for the remote disk is. Currently only supported for GCP HYPERDISK_BALANCED disks.
- `total_initial_remote_disk_size` (int32, optional)
  If set, what the total initial volume size (in GB) of the remote disks should be. Supported for GCP.
- `dependency_mode` (string, optional, Beta)
  Controls dependency configuration for the cluster.
  Possible values: `DEPENDENCY_MODE_UNSPECIFIED`, `DEPENDENCY_MODE_ENVIRONMENTS`, `DEPENDENCY_MODE_CLUSTER_LIBRARIES`, `DEPENDENCY_MODE_AUTO`

## Returns

- `cluster_id` (string, optional)
  Example: `1234-567890-cited123`

## Request

### Autoscaling cluster

```json
{
  "autoscale": {
    "max_workers": 50,
    "min_workers": 2
  },
  "aws_attributes": {
    "availability": "SPOT_WITH_FALLBACK",
    "ebs_volume_count": 0,
    "first_on_demand": 1,
    "spot_bid_price_percent": 100,
    "zone_id": "auto"
  },
  "cluster_name": "autoscaling-cluster",
  "node_type_id": "r3.xlarge",
  "spark_version": "14.3.x-scala2.12"
}
```

### Cluster with spot instances

```json
{
  "aws_attributes": {
    "availability": "SPOT",
    "first_on_demand": 1,
    "zone_id": "us-west-2a"
  },
  "cluster_name": "my-cluster",
  "node_type_id": "r3.xlarge",
  "num_workers": 25,
  "spark_conf": {
    "spark.speculation": true
  },
  "spark_version": "14.3.x-scala2.12"
}
```

### Create Machine Learning Runtime with Kind Cluster

```json
{
  "aws_attributes": {
    "availability": "SPOT_WITH_FALLBACK",
    "ebs_volume_count": 0,
    "first_on_demand": 1,
    "spot_bid_price_percent": 100,
    "zone_id": "auto"
  },
  "cluster_name": "machine-learning-with-kind-cluster",
  "kind": "CLASSIC_PREVIEW",
  "node_type_id": "i3.xlarge",
  "num_workers": 3,
  "spark_version": "15.4.x-scala2.12",
  "use_ml_runtime": true
}
```

### Create Single Node Cluster

```json
{
  "aws_attributes": {
    "availability": "SPOT_WITH_FALLBACK",
    "ebs_volume_count": 0,
    "first_on_demand": 1,
    "spot_bid_price_percent": 100,
    "zone_id": "auto"
  },
  "cluster_name": "single-node-cluster",
  "custom_tags": {
    "ResourceClass": "SingleNode"
  },
  "node_type_id": "i3.xlarge",
  "num_workers": 0,
  "spark_conf": {
    "spark.databricks.cluster.profile": "singleNode",
    "spark.master": "local[*, 4]"
  },
  "spark_version": "14.3.x-scala2.12"
}
```

### Create Single Node with Kind Cluster

```json
{
  "aws_attributes": {
    "availability": "SPOT_WITH_FALLBACK",
    "ebs_volume_count": 0,
    "first_on_demand": 1,
    "spot_bid_price_percent": 100,
    "zone_id": "auto"
  },
  "cluster_name": "single-node-with-kind-cluster",
  "is_single_node": true,
  "kind": "CLASSIC_PREVIEW",
  "node_type_id": "i3.xlarge",
  "spark_version": "14.3.x-scala2.12"
}
```

## Response

```json
{
  "cluster_id": "1234-567890-cited123"
}
```

